#lang racket
;; Generalize queue code to support multiple
;; queues.

(define-struct q (en-ch de-ch))

(define (create-queue)
  (define enqueue-ch (make-channel))
  (define dequeue-ch (make-channel))
  
  (define (serve items)
    (sync (handle-evt enqueue-ch
                      (lambda (item)
                        (serve (append items
                                       (list item)))))
          (if (empty? items)
              never-evt
              (handle-evt dequeue-ch
                          (lambda (reply-ch)
                            (channel-put reply-ch (first items))
                            (serve (rest items)))))))
  
  (thread (lambda () (serve empty)))
  
  (make-q enqueue-ch dequeue-ch))

(define q1 (create-queue))
(define q2 (create-queue))

(channel-put (q-en-ch q1) 10)
(channel-put (q-en-ch q2) 20)

(define (dequeue q)
  (let ([reply-ch (make-channel)])
    (channel-put (q-de-ch q) reply-ch)
    (channel-get reply-ch)))

(dequeue q1)
(dequeue q2)
